VERSION 5.00
Begin VB.Form AA_About 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "About Antenna Analyzer Software"
   ClientHeight    =   3630
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6435
   ClipControls    =   0   'False
   Icon            =   "AA_About.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3630
   ScaleWidth      =   6435
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox Logo 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   540
      Left            =   2880
      Picture         =   "AA_About.frx":030A
      ScaleHeight     =   510
      ScaleWidth      =   510
      TabIndex        =   5
      Top             =   120
      Width           =   540
   End
   Begin VB.CommandButton cmdOK 
      BackColor       =   &H00C0C0C0&
      Cancel          =   -1  'True
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   465
      Left            =   5160
      Style           =   1  'Graphical
      TabIndex        =   0
      Tag             =   "OK"
      ToolTipText     =   "Exit"
      Top             =   2520
      Width           =   1230
   End
   Begin VB.CommandButton cmdSysInfo 
      BackColor       =   &H00C0C0C0&
      Caption         =   "&System Info..."
      Height          =   465
      Left            =   5160
      Style           =   1  'Graphical
      TabIndex        =   1
      Tag             =   "&System Info..."
      Top             =   3120
      Width           =   1215
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "By IZ0CWZ - IK0SPX"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   120
      TabIndex        =   6
      Top             =   2640
      Width           =   1815
   End
   Begin VB.Label lblTitle 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "ANTENNA ANALYZER FROM 0 TO 160 mHz"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   240
      Left            =   960
      TabIndex        =   4
      Top             =   840
      Width           =   4545
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      BorderStyle     =   6  'Inside Solid
      Index           =   1
      X1              =   120
      X2              =   6360
      Y1              =   2430
      Y2              =   2430
   End
   Begin VB.Label lblVersion 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Height          =   195
      Left            =   1560
      TabIndex        =   3
      Tag             =   "Versione"
      Top             =   1920
      Width           =   3285
   End
   Begin VB.Label lblDisclaimer 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "( Pay attention Programme  on Beta Test !!)"
      ForeColor       =   &H00000000&
      Height          =   195
      Left            =   1680
      TabIndex        =   2
      Tag             =   "Avviso: ..."
      Top             =   1320
      Width           =   3045
   End
End
Attribute VB_Name = "AA_About"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Opzioni di protezione delle chiavi del registro di configurazione.
Const KEY_ALL_ACCESS = &H2003F
                                          

' Chiavi di primo livello del registro di configurazione.
Const HKEY_LOCAL_MACHINE = &H80000002
Const ERROR_SUCCESS = 0
Const REG_SZ = 1                         ' Stringa Unicode a terminazione Null.
Const REG_DWORD = 4                      ' Numero a 32 bit.


Const gREGKEYSYSINFOLOC = "SOFTWARE\Microsoft\Shared Tools Location"
Const gREGVALSYSINFOLOC = "MSINFO"
Const gREGKEYSYSINFO = "SOFTWARE\Microsoft\Shared Tools\MSINFO"
Const gREGVALSYSINFO = "PATH"


Private Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long


Private Sub Form_Load()
    lblVersion.Caption = App.Title & " " & " Version : " & App.Major & "." & App.Minor & "." & App.Revision
    'lblTitle.Caption = App.Title
End Sub

Private Sub cmdSysInfo_Click()
        Call StartSysInfo
End Sub

Private Sub cmdOK_Click()
        Unload Me
End Sub

Public Sub StartSysInfo()
    On Error GoTo SysInfoErr


        Dim rc As Long
        Dim SysInfoPath As String
 
        ' Tenta di recuperare il percorso\nome del programma System Info dal
        ' registro di configurazione.
        If GetKeyValue(HKEY_LOCAL_MACHINE, gREGKEYSYSINFO, gREGVALSYSINFO, SysInfoPath) Then
        ' Tenta di recuperare solo il percorso del programma System Info dal
        ' registro di configurazione.
        ElseIf GetKeyValue(HKEY_LOCAL_MACHINE, gREGKEYSYSINFOLOC, gREGVALSYSINFOLOC, SysInfoPath) Then
                ' Convalida l'esistenza di una versione nota a 32 bit del file.
                If (Dir(SysInfoPath & "\MSINFO32.EXE") <> "") Then
                        SysInfoPath = SysInfoPath & "\MSINFO32.EXE"
  
                ' Errore - Impossibile trovare il file.
                Else
                        GoTo SysInfoErr
                End If
        ' Errore - Impossibile trovare la voce del registro di configurazione.
        Else
                GoTo SysInfoErr
        End If

        Call Shell(SysInfoPath, vbNormalFocus)
 
        Exit Sub
SysInfoErr:
        MsgBox "System Infos nto availlable now.", vbOKOnly
End Sub

Public Function GetKeyValue(KeyRoot As Long, KeyName As String, SubKeyRef As String, ByRef KeyVal As String) As Boolean
        Dim i As Long                                           ' Contatore del ciclo.
        Dim rc As Long                                          ' Codice restituito.
        Dim hKey As Long                                        ' Handle a una chiave del registro di configurazione aperta.
        Dim hDepth As Long                                      '
        Dim KeyValType As Long                                  ' Tipo di dati di una chiave del registro di configurazione.
        Dim tmpVal As String                                    ' Variabile per la memorizzazione temporanea del valore di una chiave del registro di configurazione.
        Dim KeyValSize As Long                                  ' Dimensioni della variabile della chiave del registro di configurazione.
        '------------------------------------------------------------
        ' Open RegKey Under KeyRoot {HKEY_LOCAL_MACHINE...}
        '------------------------------------------------------------
        rc = RegOpenKeyEx(KeyRoot, KeyName, 0, KEY_ALL_ACCESS, hKey) ' Apre la chiave del registro di configurazione.
        

        If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError          ' Gestisce l'errore.
        

        tmpVal = String$(1024, 0)                             ' Assegna spazio per la variabile.
        KeyValSize = 1024                                       ' Imposta le dimensioni della variabile.
        

        '----------------------------------------------------------------
        ' Recupera il valore della chiave del registro di configurazione.
        '----------------------------------------------------------------
        rc = RegQueryValueEx(hKey, SubKeyRef, 0, KeyValType, tmpVal, KeyValSize)    ' Recupera/crea il valore della chiave.
                                                

        If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError          ' Gestisce gli errori.
        

        tmpVal = VBA.Left(tmpVal, InStr(tmpVal, VBA.Chr(0)) - 1)
        '------------------------------------------------------------
        ' Determina il tipo di valore della chiave per la conversione.
        '------------------------------------------------------------
        Select Case KeyValType                                  ' Cerca i tipi di dati.
        Case REG_SZ                                             ' Tipo di dati String per la chiave del registro di configurazione.
                KeyVal = tmpVal                                     ' Copia il valore String.
        Case REG_DWORD                                          ' Tipo di dati Double Word per la chiave del registro di configurazione.
                For i = Len(tmpVal) To 1 Step -1                    ' Converte ogni bit.
                        KeyVal = KeyVal + Hex(Asc(Mid(tmpVal, i, 1)))   ' Crea il valore carattere per carattere.
                Next
                KeyVal = Format$("&h" + KeyVal)                     ' Converte Double Word in String.
        End Select
        

        GetKeyValue = True                                      ' Esito positivo.
        rc = RegCloseKey(hKey)                                  ' Chiude la chiave del registro di configurazione.
        Exit Function                                           ' Esce.
        

GetKeyError:    ' Svuota in seguito a un errore.
        KeyVal = ""                                             ' Imposta il valore restituito su una stringa vuota.
        GetKeyValue = False                                     ' Esito negativo.
        rc = RegCloseKey(hKey)                                  ' Chiude la chiave del registro di configurazione.
End Function

